---
title: class expression
slug: Web/JavaScript/Reference/Operators/class
tags:
  - Classes
  - ECMAScript 2015
  - Expression
  - JavaScript
  - Language feature
  - Operator
  - Reference
---
<div>{{jsSidebar("Operators")}}</div>

<p><span class="seoSummary">The <strong>class expression</strong> is one way to define a class in ECMAScript 2015. Similar to {{jsxref("Operators/function", "function expressions", "", "true")}}, class expressions can be named or unnamed. If named, the name of the class is local to the class body only. </span></p>

<p>JavaScript classes use prototype-based inheritance.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-classexpression.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const <var>MyClass</var> = class [<var>className</var>] [extends <var>otherClassName</var>] {
    // class body
};</pre>

<h2 id="Description">Description</h2>

<p>A class expression has a similar syntax to a {{jsxref("Statements/class", "class declaration (statement)", "", "true")}}. As with <code>class</code> statements, the body of a <code>class</code> expression is executed in {{jsxref("Strict_mode", "strict mode", "", 1)}}.</p>

<p>There are several differences between class expressions and {{jsxref("Statements/class", "class statements", "", "true")}}, however:</p>

<ul>
 <li>Class expressions may omit the class name ("binding identifier"), which is not possible with {{jsxref("Statements/class", "class statements", "", "true")}}.</li>
 <li>Class expressions allow you to redefine (re-declare) classes <strong>without throwing</strong> a {{jsxref("Global_Objects/SyntaxError", "SyntaxError")}}. This is not the case with {{jsxref("Statements/class", "class statements", "", "true")}}.</li>
</ul>

<p>The <code>constructor</code> method is optional. Classes generated with class expressions will always respond to {{jsxref("Operators/typeof", "typeof")}} with the value "<code>function</code>".</p>

<pre class="brush: js">'use strict';
let Foo = class {};  // constructor property is optional
Foo = class {};      // Re-declaration is allowed

typeof Foo;             // returns "function"
typeof class {};        // returns "function"

Foo instanceof Object;   // true
Foo instanceof Function; // true
class Foo {}            // Throws SyntaxError (class <em>declarations</em> do not allow re-declaration)
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="A_simple_class_expression">A simple class expression</h3>

<p>This is just a simple anonymous class expression which you can refer to using the variable <code>Foo</code>.</p>

<pre class="brush: js">const Foo = class {
  constructor() {}
  bar() {
    return 'Hello World!';
  }
};

const instance = new Foo();
instance.bar();  // "Hello World!"
Foo.name;        // "Foo"
</pre>

<h3 id="Named_class_expressions">Named class expressions</h3>

<p>If you want to refer to the current class inside the class body, you can create a <em>named class expression</em>. The name is only visible within the scope of the class expression itself.</p>

<pre class="brush: js">const Foo = class NamedFoo {
  constructor() {}
  whoIsThere() {
    return NamedFoo.name;
  }
}
const bar = new Foo();
bar.whoIsThere();  // "NamedFoo"
NamedFoo.name;     // ReferenceError: NamedFoo is not defined
Foo.name;          // "NamedFoo"
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-class-definitions', 'Class definitions')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.class")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Operators/function", "function expression", "", "true")}}</li>
 <li>{{jsxref("Statements/class", "class declaration", "", "true")}}</li>
 <li>{{jsxref("Classes", "Classes", "", "true")}}</li>
</ul>
